diff --git a/yum/depsolve.py b/yum/depsolve.py
index 6d744c0..cb0ebea 100644
--- a/yum/depsolve.py
+++ b/yum/depsolve.py
@@ -31,13 +31,15 @@ from transactioninfo import TransactionMember
 import rpm
 
 from packageSack import ListPackageSack
+from packages import PackageEVR
 from constants import *
-import packages
 import logginglevels
 import Errors
 import warnings
 warnings.simplefilter("ignore", Errors.YumFutureDeprecationWarning)
 
+from weakref import proxy as weakref
+
 from yum import _, _rpm_ver_atleast
 
 try:
@@ -58,12 +60,51 @@ flags = {"GT": rpm.RPMSENSE_GREATER,
          "LE": rpm.RPMSENSE_LESS | rpm.RPMSENSE_EQUAL,
          "EQ": rpm.RPMSENSE_EQUAL,
          None: 0 }
+_rflags = {}
+for f in flags:
+    _rflags[flags[f]] = f
+
+
+class _wrap_ayum_getPkgSack:
+    """ This is a wrapper for calling YumBase.pkgSack because
+        otherwise we take a real reference through the bound method and
+        that is d00m (this applies to YumBase and TransactionInfo, hence why
+        we have a separate class). """
+    def __init__(self, ayum):
+        self.ayum = weakref(ayum)
+    def __call__(self):
+        return self.ayum.pkgSack
+
+class _wrap_ayum_install:
+    """ This is a wrapper for calling YumBase.install because
+        otherwise we take a real reference through the bound method and
+        that is d00m (this applies to YumBase and TransactionInfo, hence why
+        we have a separate class). """
+    def __init__(self, ayum):
+        self.ayum = weakref(ayum)
+    def __call__(self, *args, **kwargs):
+        return self.ayum.install(*args, **kwargs)
+class _wrap_ayum_remove:
+    """ This is a wrapper for calling YumBase.remove because
+        otherwise we take a real reference through the bound method and
+        that is d00m (this applies to YumBase and TransactionInfo, hence why
+        we have a separate class). """
+    def __init__(self, ayum):
+        self.ayum = weakref(ayum)
+    def __call__(self, *args, **kwargs):
+        return self.ayum.remove(*args, **kwargs)
+class _wrap_ayum_update:
+    """ This is a wrapper for calling YumBase.update because
+        otherwise we take a real reference through the bound method and
+        that is d00m (this applies to YumBase and TransactionInfo, hence why
+        we have a separate class). """
+    def __init__(self, ayum):
+        self.ayum = weakref(ayum)
+    def __call__(self, *args, **kwargs):
+        return self.ayum.update(*args, **kwargs)
 
 class Depsolve(object):
-
-    """
-    Dependency resolving class.
-    """
+    """A class for resolving dependencies."""
 
     def __init__(self):
         self._ts = None
@@ -81,6 +122,8 @@ class Depsolve(object):
         self.installedUnresolvedFileRequires = None
 
     def doTsSetup(self):
+        """Sets up the transaction set before it is used."""
+
         warnings.warn(_('doTsSetup() will go away in a future version of Yum.\n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)
         return self._getTs()
@@ -92,7 +135,8 @@ class Depsolve(object):
         
         if self._tsInfo != None and self._ts != None:
             if not remove_only and self._tsInfo.pkgSack is None:
-                self._tsInfo.setDatabases(self.rpmdb, self.pkgSack)
+                pkgSackCtor = _wrap_ayum_getPkgSack(self)
+                self._tsInfo.setDatabases(self.rpmdb, None, pkgSackCtor)
             return
             
         if not self.conf.installroot:
@@ -108,14 +152,17 @@ class Depsolve(object):
             self._tsInfo = self._transactionDataFactory()
             if remove_only:
                 pkgSack = None
+                pkgSackCtor = None
             else:
-                pkgSack = self.pkgSack
-            self._tsInfo.setDatabases(self.rpmdb, pkgSack)
+                # Don't instant setup, or things like localinstall are screwed.
+                pkgSack = None
+                pkgSackCtor = _wrap_ayum_getPkgSack(self)
+            self._tsInfo.setDatabases(self.rpmdb, pkgSack, pkgSackCtor)
             self._tsInfo.installonlypkgs = self.conf.installonlypkgs # this kinda sucks
             # this REALLY sucks, sadly (needed for group conditionals)
-            self._tsInfo.install_method = self.install
-            self._tsInfo.update_method = self.update
-            self._tsInfo.remove_method = self.remove
+            self._tsInfo.install_method = _wrap_ayum_install(self)
+            self._tsInfo.update_method = _wrap_ayum_update(self)
+            self._tsInfo.remove_method = _wrap_ayum_remove(self)
         return self._tsInfo
 
     def _setTsInfo(self, value):
@@ -131,8 +178,15 @@ class Depsolve(object):
         
 
     def initActionTs(self):
-        """sets up the ts we'll use for all the work"""
+        """Set up the transaction set that will be used for all the work."""
         
+        # LOL, override rpm transaction macro.
+        # Must be done before rpmtsCreate()
+        if self.conf.override_install_langs:
+            old_install_langs = rpm.expandMacro("%_install_langs")
+            rpm.expandMacro("%define _install_langs " +
+                            self.conf.override_install_langs)
+
         self._ts = rpmUtils.transaction.TransactionWrapper(self.conf.installroot)
         ts_flags_to_rpm = { 'noscripts': rpm.RPMTRANS_FLAG_NOSCRIPTS,
                             'notriggers': rpm.RPMTRANS_FLAG_NOTRIGGERS,
@@ -152,25 +206,41 @@ class Depsolve(object):
             else:
                 self.logger.critical(_('Invalid tsflag in config file: %s'), flag)
 
+        if not self.conf.diskspacecheck:
+            self._add_prob_flags(rpm.RPMPROB_FILTER_DISKSPACE,
+                                 rpm.RPMPROB_FILTER_DISKNODES)
+
         probfilter = 0
         for flag in self.tsInfo.probFilterFlags:
             probfilter |= flag
         self._ts.setProbFilter(probfilter)
 
     def whatProvides(self, name, flags, version):
-        """searches the packageSacks for what provides the arguments
-           returns a ListPackageSack of providing packages, possibly empty"""
-
+        """Search the packageSacks for what provides the specified
+        feature or file.
+      
+        :param name: a string specifying the file or feature to search
+           for
+        :param flags: flags related to the search
+        :param version: the version to search for
+        :return: a :class:`ListPackagaSack` containing the packages
+           that match the arguments, and may be empty
+        """
         self.verbose_logger.log(logginglevels.DEBUG_1, _('Searching pkgSack for dep: %s'),
             name)
         defSack = ListPackageSack(self.pkgSack.searchProvides((name, flags, version)))
         return defSack
         
     def allowedMultipleInstalls(self, po):
-        """takes a packageObject, returns 1 or 0 depending on if the package 
-           should/can be installed multiple times with different vers
-           like kernels and kernel modules, for example"""
-
+        """Return whether the given package object can be installed
+        multiple times with different versions.  For example, this
+        would be true of kernels and kernel modules.
+
+        :param po: the package object that this function will
+           determine whether can be install multiple times
+        :return: a boolean specifying whether *po* can be installed
+           multiple times
+        """
         iopkgs = set(self.conf.installonlypkgs)
         if po.name in iopkgs:
             return True
@@ -182,8 +252,11 @@ class Depsolve(object):
         return False
 
     def populateTs(self, test=0, keepold=1):
-        """take transactionData class and populate transaction set"""
+        """Populate the transaction set.
 
+        :param test: unused
+        :param keepold: whether to keep old packages
+        """
         if self.dsCallback: self.dsCallback.transactionPopulation()
         ts_elem = {}
         
@@ -393,9 +466,27 @@ class Depsolve(object):
             self.conf.obsoletes = 0
             txmbrs = self.update(po=requiringPo, requiringPo=requiringPo)
             self.conf.obsoletes = origobs
-            if not txmbrs:
+
+            def _check_update_worked(txmbrs, obs=False):
+                #  Old code assumed that if there was an update, we were good:
+                #    if txmbrs: return True
+                # ..however we have a problem when foo-1 and foo-2 both require
+                # bar-1, and bar-2 is being installed. If the req. is identical
+                # then we'll skip checking it in _checkInstall(), so we need to
+                # check it here.
+                for txmbr in txmbrs:
+                    if obs or txmbr.name == requiringPo.name:
+                        n,f,v = requirement
+                        creq = (n, _rflags[f],
+                                rpmUtils.miscutils.stringToVersion(v))
+                        # If it's identical ... checkInstall will skip it.
+                        if creq not in txmbr.po.requires:
+                            return True
+                return False
+
+            if not _check_update_worked(txmbrs):
                 txmbrs = self.update(po=requiringPo, requiringPo=requiringPo)
-                if not txmbrs:
+                if not _check_update_worked(txmbrs, obs=True):
                     msg = self._err_missing_requires(requiringPo, requirement)
                     self.verbose_logger.log(logginglevels.DEBUG_2, _('No update paths found for %s. Failure!'), requiringPo)
                     return self._requiringFromTransaction(requiringPo, requirement, errorlist)
@@ -405,12 +496,30 @@ class Depsolve(object):
             # try to update the requiring package in hopes that all this problem goes away :(
             self.verbose_logger.log(logginglevels.DEBUG_2, _('Trying to update %s to resolve dep'), requiringPo)
             txmbrs = self.update(po=requiringPo, requiringPo=requiringPo)
+            fixed = False
             if not txmbrs:
                 msg = self._err_missing_requires(requiringPo, requirement)
-                self.verbose_logger.log(logginglevels.DEBUG_2, _('No update paths found for %s. Failure!'), requiringPo)
+                self.verbose_logger.log(logginglevels.DEBUG_2, _('No update paths found for %s. Failure due to requirement: %s!'), requiringPo, msg)
+            else:
+                req_lookup = (needname, needflags,
+                              rpmUtils.miscutils.stringToVersion(needversion))
+
+            for txmbr in txmbrs:
+                #  This works for upgrades, and for obsoletes, on one side.
+                # Also catches upgrades that don't work on the other.
+                if txmbr.output_state in TS_INSTALL_STATES:
+                    if txmbr.po.checkPrco('requires', req_lookup):
+                        fixed = False
+                        break
+                    else:
+                        fixed = True
+            if txmbrs and not fixed:
+                msg = self._err_missing_requires(requiringPo, requirement)
+                self.verbose_logger.log(logginglevels.DEBUG_2, _("Update for %s. Doesn't fix requirement: %s!"), requiringPo, msg)
+
+            if not fixed:
                 return self._requiringFromTransaction(requiringPo, requirement, errorlist)
             checkdeps = 1
-
             
         if needmode in ['e']:
             self.verbose_logger.log(logginglevels.DEBUG_2, _('TSINFO: %s package requiring %s marked as erase'),
@@ -589,7 +698,7 @@ class Depsolve(object):
             #  Always do compare providers for multiple pkgs, it deals with
             # newest etc. ... so no need to do NewestNameArch() ... and it
             # stops compare_providers from being clever.
-            pkgresults = self._compare_providers(pkgs, requiringPo)
+            pkgresults = self._compare_providers(pkgs, requiringPo,req=needname)
             best = pkgresults[0][0]
         
         if self.rpmdb.contains(po=best): # is it already installed?
@@ -609,13 +718,31 @@ class Depsolve(object):
             # FIXME: we should probably handle updating multiple packages...
             txmbr = self.tsInfo.addUpdate(best, inst[0])
             txmbr.setAsDep(po=requiringPo)
-            txmbr.reason = "dep"
+            if 'reason' in inst[0].yumdb_info:
+                txmbr.reason = inst[0].yumdb_info.reason
+            else:
+                txmbr.reason = 'dep'
             checkdeps = True
             self._last_req = best
         else:
             self.verbose_logger.debug(_('TSINFO: Marking %s as install for %s'), best,
                 requiringPo)
-            reqtuple = misc.string_to_prco_tuple(needname + str(needflags) + needversion)
+            if requirement and not requirement[2]:
+                #  Stuff looks like: ('/foo', 0, '') ... might be just testing
+                # noise, but meh.
+                reqtuple = (requirement[0], requirement[1], (None, None, None))
+            elif len(requirement) == 3 and len(requirement[2]) == 3:
+                # Without the above check, we've hit this in mash:
+                #  File "/usr/.../yum/__init__.py", line 4862, in install
+                #    if not obsoleting_pkg.provides_for(kwargs['provides_for']):
+                #  File "/usr/.../yum/packages.py", line 594, in provides_for
+                #    if self.checkPrco('provides', reqtuple):
+                #   File "/usr/.../yum/packages.py", line 544, in checkPrco
+                #    (reqn, reqf, (reqe, reqv ,reqr)) = prcotuple
+                # ValueError: too many values to unpack
+                reqtuple = requirement
+            else:
+                reqtuple = misc.string_to_prco_tuple(needname + str(needflags) + needversion)
             txmbrs = self.install(best, provides_for=reqtuple)
             for txmbr in txmbrs:
                 txmbr.setAsDep(po=requiringPo)
@@ -696,6 +823,13 @@ class Depsolve(object):
                 self.tsInfo.remove(txmbr.pkgtup)
 
     def prof_resolveDeps(self):
+        """Call :func:`resolveDeps`, and profile the call using the
+        hotshot profiler.
+
+        :return: a tuple containing the result code and a list of
+           result strings.  This is simply the return value of
+           :func:`resolveDeps` being passed up.
+        """
         fn = "anaconda.prof.0"
         import hotshot, hotshot.stats
         prof = hotshot.Profile(fn)
@@ -709,6 +843,13 @@ class Depsolve(object):
         return rc
 
     def cprof_resolveDeps(self):
+        """Call :func:`resolveDeps`, and profile the call using the
+        cprof profiler.
+
+        :return: a tuple containing the result code and a list of
+           result strings.  This is simply the return value of
+           :func:`resolveDeps` being passed up.
+        """
         import cProfile, pstats
         prof = cProfile.Profile()
         rc = prof.runcall(self.resolveDeps)
@@ -722,7 +863,17 @@ class Depsolve(object):
         return rc
 
     def resolveDeps(self, full_check=True, skipping_broken=False):
-
+        """Resolve dependencies for the packages in the current
+        trasaction set.
+        
+        :param full_check: whether to also check removes and installs,
+           as well as dependencies
+        :param skipping_broken: if this is true, a message saying that
+           dependency solving has finished successfully will not be output.
+           This is useful since if there are broken packages that are
+           being skipped, :func:`resolveDeps` will need to be called
+           multiple times before dependency solving is completely finished
+        """
         if not len(self.tsInfo):
             return (0, [_('Success - empty transaction')])
 
@@ -740,7 +891,11 @@ class Depsolve(object):
 
         if self.dsCallback: self.dsCallback.start()
 
+        depsolve_loop_count = 0
         while True:
+            if depsolve_loop_count == (self.conf.depsolve_loop_limit or -1):
+                return (1, [_("Depsolving loop limit reached.")] + unique(errors))
+            depsolve_loop_count += 1
 
             CheckDeps = True
 
@@ -778,6 +933,12 @@ class Depsolve(object):
                     if checkdep:
                         break # The next conflict might be the same pkg
 
+                if True: # Always have to check obsoletes...
+                    if self._checkObsoletes():
+                        CheckDeps = True
+                        CheckRemoves = True
+                        self._last_req = None
+
                 if CheckDeps:
                     if self.dsCallback: self.dsCallback.restartLoop()
                     self.verbose_logger.log(logginglevels.DEBUG_1, _('Restarting Loop'))
@@ -920,9 +1081,12 @@ class Depsolve(object):
 
         # if this is an update, we should check what the old
         # requires were to make things faster
+        #  Note that if the rpmdb is broken, this gets annoying. So we provide
+        # a way to turn it off.
         oldreqs = []
-        for oldpo in txmbr.updates:
-            oldreqs.extend(oldpo.returnPrco('requires'))
+        if not self.conf.recheck_installed_requires:
+            for oldpo in txmbr.updates:
+                oldreqs.extend(oldpo.returnPrco('strong_requires'))
         oldreqs = set(oldreqs)
 
         ret = []
@@ -948,7 +1112,7 @@ class Depsolve(object):
                     continue
                 for member in self.tsInfo.getMembersWithState(
                     pkgtup=po.pkgtup, output_states=TS_INSTALL_STATES):
-                    member.relatedto.append((txmbr.po, 'dependson'))
+                    member.setAsDep(txmbr.po, relonly=True)
 
         return ret
 
@@ -974,12 +1138,36 @@ class Depsolve(object):
             # FIXME: This is probably the best place to fix the postfix rename
             # problem long term (post .21) ... see compare_providers.
             for pkg, hits in self.tsInfo.getRequires(*prov).iteritems():
-                # See the docs, this is to make groupremove "more useful".
+                # See the docs, this is to make remove* "more useful".
+                if (self.conf.repopkgsremove_leaf_only and txmbr.repopkg and
+                    txmbr.output_state == TS_ERASE):
+                    cb = self.dsCallback
+                    if cb and hasattr(cb, 'repoPkgRemoveReq'):
+                        cb.repoPkgRemoveReq(txmbr.po, hits)
+                    elif cb and hasattr(cb, 'removeReq'):
+                        cb.removeReq(txmbr.po, pkg, hits)
+                    #  We don't undo anything else here ... hopefully that's
+                    # fine.
+                    self.tsInfo.remove(txmbr.pkgtup)
+                    return []
+
                 if (self.conf.groupremove_leaf_only and txmbr.groups and
                     txmbr.output_state == TS_ERASE):
                     cb = self.dsCallback
                     if cb and hasattr(cb, 'groupRemoveReq'):
                         cb.groupRemoveReq(pkg, hits)
+                    elif cb and hasattr(cb, 'removeReq'):
+                        cb.removeReq(txmbr.po, pkg, hits)
+                    #  We don't undo anything else here ... hopefully that's
+                    # fine.
+                    self.tsInfo.remove(txmbr.pkgtup)
+                    return []
+
+                if (self.conf.remove_leaf_only and
+                    txmbr.output_state == TS_ERASE):
+                    cb = self.dsCallback
+                    if cb and hasattr(cb, 'removeReq'):
+                        cb.removeReq(txmbr.po, pkg, hits)
                     #  We don't undo anything else here ... hopefully that's
                     # fine.
                     self.tsInfo.remove(txmbr.pkgtup)
@@ -1033,10 +1221,10 @@ class Depsolve(object):
 
         # get file requirements from new packages
         for txmbr in self._tsInfo.getMembersWithState(output_states=TS_INSTALL_STATES):
+            files = []
             for name, flag, evr in txmbr.po.requires:
                 if name.startswith('/'):
-                    pt = txmbr.po.pkgtup
-                    self.installedFileRequires.setdefault(pt, []).append(name)
+                    files.append(name)
                     # check if file requires was already unresolved in update
                     if name in self.installedUnresolvedFileRequires:
                         already_broken = False
@@ -1050,6 +1238,7 @@ class Depsolve(object):
                         nfileRequires.add(name)
                     fileRequires.add(name)
                     reverselookup.setdefault(name, []).append(txmbr.po.pkgtup)
+            self.installedFileRequires[txmbr.po.pkgtup] = files
 
         todel = []
         for fname in self.installedFileProviders:
@@ -1149,7 +1338,74 @@ class Depsolve(object):
         self.rpmdb.transactionCacheConflictPackages(cpkgs)
         return ret
 
+    #  This is checking for installed / transaction members which
+    # obsolete each other. Because rpm will now auto. obs. those
+    # anyway (even if we have obsoletes turned off).
+    def _checkObsoletes(self):
+        opkgs = []
+
+        ret = False
+
+        def _do_obs(otxmbr):
+            self.tsInfo.remove(otxmbr.pkgtup)
+            #  We need to remove an obsoleted entry that
+            # was maybe used to resolve something ... ?
+            self.pkgSack.delPackage(otxmbr.po)
+            self.up.delPackage(otxmbr.pkgtup)
+            # Remove it from the installed file requires cache
+            (self.installedFileRequires or {}).pop(otxmbr.pkgtup, None)
+
+        for po in self.rpmdb.returnObsoletePackages():
+            if self.tsInfo.getMembersWithState(po.pkgtup, output_states=TS_REMOVE_STATES):
+                continue
+            obsoletes = po.returnPrco('obsoletes')
+            if not obsoletes: # We broke this due to dbMatch() usage.
+                continue
+            opkgs.append(po)
+            for obs_name,f,v in obsoletes:
+                for otxmbr in self.tsInfo.matchNaevr(name=obs_name):
+                    if not otxmbr.po.obsoletedBy([po]):
+                        continue
+                    if po.obsoletedBy([otxmbr.po]): # Loops, hope for rpm.
+                        continue
+                    msg = _('Removing %s due to obsoletes from installed %s')
+                    self.verbose_logger.warning(msg, otxmbr, po)
+                    _do_obs(otxmbr)
+                    ret = True
+
+        for txmbr in self.tsInfo.getMembersWithState(None, output_states=TS_INSTALL_STATES):
+            done = False
+            for obs_n in txmbr.po.obsoletes_names:
+                if not done:
+                    opkgs.append(txmbr.po)
+                    done = True
+
+                for otxmbr in self.tsInfo.matchNaevr(name=obs_n):
+                    if otxmbr.output_state not in TS_INSTALL_STATES:
+                        continue
+                    if otxmbr.po == txmbr.po:
+                        #  Not sure if we should just ignore this for
+                        # us, or for everyone...
+                        continue
+                    if not otxmbr.po.obsoletedBy([txmbr.po]):
+                        continue
+                    if txmbr.po.obsoletedBy([otxmbr.po]):
+                        # Have to deal with loops! Hope rpm behaves too.
+                        continue
+                    msg = _('Removing %s due to obsoletes from %s')
+                    self.verbose_logger.warning(msg, otxmbr, txmbr)
+                    _do_obs(otxmbr)
+                    ret = True
+
+        self.rpmdb.transactionCacheObsoletePackages(opkgs)
+        return ret
+
     def isPackageInstalled(self, pkgname):
+        """Return whether the given package in installed.
+
+        :param pkgname: the name of the package
+        :return: whether the package in installed
+        """
         lst = self.tsInfo.matchNaevr(name = pkgname)
         for txmbr in lst:
             if txmbr.output_state in TS_INSTALL_STATES:
@@ -1166,7 +1422,7 @@ class Depsolve(object):
         return True
     _isPackageInstalled = isPackageInstalled
 
-    def _compare_providers(self, pkgs, reqpo):
+    def _compare_providers(self, pkgs, reqpo, req=None):
         """take the list of pkgs and score them based on the requesting package
            return a dictionary of po=score"""
         self.verbose_logger.log(logginglevels.DEBUG_4,
@@ -1210,6 +1466,24 @@ class Depsolve(object):
                 return None
             return x
 
+        def _pkg2prov_version(pkg, provname):
+            ''' This converts a package into a specific version tuple for the
+            required provide. The provide _must_ be '=' and epoch=None and
+            release=None == '0'.
+               If there is 0 or 2+ matches, return None.
+               If the req does not == the provide name, return None. '''
+            ret = None
+            for prov in pkg.provides:
+                (n, f, (e, v, r)) = prov
+                if n != provname:
+                    continue
+                if f != 'EQ':
+                    continue
+                if ret is not None:
+                    return None
+                ret = (e or '0', v, r or '0')
+            return ret
+
         #  Actual start of _compare_providers().
 
         # Do a NameArch filtering, based on repo. __cmp__
@@ -1332,6 +1606,29 @@ class Depsolve(object):
                         _('common prefix of %s between %s and %s' % (cpl, po, reqpo)))
                 
                     pkgresults[po] += cpl*2
+
+        if req is not None:
+            bestnum = max(pkgresults.values())
+            prov_depsolve = {}
+            for po in pkgs:
+                if pkgresults[po] != bestnum:
+                    continue
+                evr = _pkg2prov_version(po, req)
+                if evr is None:
+                    prov_depsolve = {}
+                    break
+                prov_depsolve[po] = evr
+            if len(prov_depsolve) > 1:
+                self.verbose_logger.log(logginglevels.DEBUG_4,
+                                        _('provides vercmp: %s') % str(req))
+                newest = sorted(prov_depsolve,
+                                key = lambda x: PackageEVR(*prov_depsolve[x]))
+                for winner in reversed(newest):
+                    if prov_depsolve[winner] != prov_depsolve[newest[-1]]:
+                        break
+                    self.verbose_logger.log(logginglevels.DEBUG_4,
+                                            _(' Winner: %s') % winner)
+                    pkgresults[winner] += 1
                 
         #  If we have more than one "best", see what would happen if we picked
         # each package ... ie. what things do they require that _aren't_ already
@@ -1393,42 +1690,52 @@ class Depsolve(object):
 
 
 class DepCheck(object):
-    """object that YumDepsolver uses to see what things are needed to close
-       the transaction set. attributes: requires, conflicts are a list of 
-       requires are conflicts in the current transaction set. Each item in the
-       lists are a requires or conflicts object"""
+    """Object that :class:`YumDepsolver` uses to see what things are
+    needed to close the transaction set. The attributes requires and
+    conflicts are lists of requires and conflicts in the current
+    transaction set. Each item in the lists is a :class:`Requires` or
+    :class:`Conflicts` object.
+    """
     def __init__(self):
         self.requires = []
         self.conflicts = []
 
     def addRequires(self, po, req_tuple_list):
+        """Create and add a :class:`Requires` object to the list of
+        requires.
+
+        :param po: the package object involved in the requires
+        :param req_tuple_list: a list of required by *po* that are
+           un-closed in the transaction set
+        """
         # fixme - do checking for duplicates or additions in here to zip things along
         reqobj = Requires(po, req_tuple_list)
         self.requires.append(reqobj)
     
     def addConflicts(self, conflict_po_list, conflict_item):
+        """Create and add a :class:`Conflicts` object to the list of
+        conflicts.
+
+        :param conflict_po_list: a list of conflicting package objects
+        :param conflict_item: what the conflict between the members of
+           *conflict_po_list is.
+        """
         confobj = Conflicts(conflict_po_list, conflict_item)
         self.conflicts.append(confobj)
 
 class Requires(object):
-
-    """
-    A pure data class for holding a package and the list of things it
-    requires.
+    """A pure data class for holding a package and the list of things
+    it requires.
     """
-
     def __init__(self, pkg,requires):
         self.pkg = pkg # po of requiring pkg
         self.requires = requires # list of things it requires that are un-closed in the ts
 
 
 class Conflicts(object):
-
+    """A pure data class for holding a list packages and what the
+    conflict between them is.
     """
-    A pure data class for holding a package and the list of things it
-    conflicts.
-    """
-
     def __init__(self, pkglist, conflict):
         self.pkglist = pkglist # list of conflicting package objects
         self.conflict = conflict # what the conflict was between them
